package com.company;

public class CharacterClass {

    int Health;
    int Defense;
    int Strength;
    String position;
    String[] inventory;

    public CharacterClass() {
        Health = 0;
        Defense = 0;
        Strength = 0;
        inventory = new String[3];

        for(int i = 0;i<3; i++) {
            inventory[i] = "Nothing";
        }
    }

    public String walk(NodeClass node, double Degree) {
        double Less = 0;
        int CordX = 0;
        int CordY = 0;
        String name = "";
        for (int i=0; i<node.links.size(); i++) {
            if (node.links.size() == 1){
                Less = node.links.get(i).Degree;
                CordX = node.links.get(i).CordX;
                CordY = node.links.get(i).CordY;
                name = node.links.get(i).destino;
            } else {
                if (i == 0) {
                    Less = node.links.get(i).Degree;
                    CordX = node.links.get(i).CordX;
                    CordY = node.links.get(i).CordY;
                    name = node.links.get(i).destino;
                } else {
                    if (Math.abs(node.links.get(i).Degree - Degree) < Math.abs(node.links.get(i - 1).Degree - Degree)) {
                        Less = node.links.get(i).Degree;
                        CordX = node.links.get(i).CordX;
                        CordY = node.links.get(i).CordY;
                        name = node.links.get(i).destino;
                    }
                }
            }
        }
        System.out.println("found a tunnel at " + (int)Less + " degrees... I’ll take it slowly");
        System.out.println("if I’m right, I should be at " + CordX + ", " + CordY);
        System.out.println("I'm in "+name);
        this.position = name;
        return name;
    }

    public void investigate(NodeClass node, CharacterClass main) {
        if (node.typeofevent == 0 && node.factor == 0) {
            EnemieClass enemieaux = (EnemieClass)node.evento;
            System.out.println("Omg it's a "+enemieaux.name+"!");
            System.out.println("I'm going to take this off guard and strike them first");
            enemieaux.action(main);
            System.out.println("That was easy... I think.");
            node.factor = 1;
        }
        else if (node.typeofevent == 1) {
            ItemClass itemaux = (ItemClass)node.evento;
            System.out.println("Let's see what we have here...");
            if (itemaux.name.equals("Tumaza")) {
                System.out.println("Are you kidding me? Is the most several, powerful and wicked weapon of the Mathematic Department.");
            } else if (itemaux.name.equals("HozHorst")) {
                System.out.println("Hahaha It seems what Horst lost his sickle. What are gonna to do the students in the exams now?");
            } else {
                System.out.println("Oh, a " + itemaux.name + "!!");
            }
            int contador=0;
            for (int i = 0 ; i < 3 ; i++) {
                if (main.inventory[i].equals("Nothing")) {
                    System.out.println("Yeah, I have a slot in my bag");
                    System.out.println("I hope that nobody miss this.");
                    main.inventory[i] = itemaux.name;
                    break;
                } else {
                    contador++;
                }
            } if (contador == 3) {
                System.out.println("But my bag is full. I need to drop a item");
            }
        } else {
            System.out.println("There are nothing here. I must move to other place maybe.");
        }
    }

    public void inventory() {
        int contador = 0;
        for(int i=0; i<3; i++) {
            if (inventory[i] != "Nothing") {
                contador++;
            }
        } if (contador == 0) {
            System.out.println("My bag is as empty as my whole life");
        } else {
            System.out.println("Let's see what's in my bag");

            for (int i=0; i<contador; i++) {
                System.out.println("("+i+") a "+inventory[i]);
            } if (contador == 3) {
                System.out.println("My bag is full!");
            } else {
                System.out.println("I can carry "+(3-contador)+" items");
            }
        }
    }

    public void use(int item_id, ItemClass item) {
        if (item.Health != 0) {
            System.out.println("Omg i needed this "+item.name+"!!");
            System.out.println("According to label of "+item.name+" I healed "+item.Health+" points");
            this.Health = this.Health + item.Health;
            drop(item_id);
        } else if (item.Defense != 0) {
            System.out.println("This "+item.name+" seems so cool");
            System.out.println("According to the commercials, my defense increased "+item.Defense+" points");
            this.Defense = this.Defense + item.Defense;
            drop(item_id);
        } else if (item.Strength != 0) {
            if (item.name.equals("Tumaza")) {
                System.out.println("It's time to punish all in my way. Get ready to reprove!");
            } else if (item.name.equals("HozHorst")) {
                System.out.println("I might be ready if I had the clothing for take the test.");
            } else {
                System.out.println("Time to equip "+item.name);
            }
            System.out.println("I feel more "+item.Strength+" points of Strength");
            this.Strength = this.Strength + item.Strength;
            drop(item_id);
        }
    }

    public void drop(int item_id) {
        System.out.println("I’ll get rid of this " + this.inventory[item_id]);
        if (item_id == 0) {
            inventory[item_id] = inventory[item_id+1];
            inventory[item_id+1] = inventory[item_id+2];
            inventory[item_id+2] = "Nothing";
        } else if (item_id == 1) {
            inventory[item_id] = inventory[item_id+1];
            inventory[item_id+1] = "Nothing";
        } else {
            inventory[item_id] = "Nothing";
        }
        inventory[item_id] = "Nothing";
        System.out.println("Well @!#$%&");

    }

}
