package com.company;

import java.util.Random;

public class EnemieClass implements CurveBasedAttributes, Event {

    String name;
    int Health;
    int Defense;
    int Strength;
    int Level;
    boolean primero;
    int probabilidad;

    public EnemieClass(String name, int level) {
        this.name = name;
        this.Health = 0;
        this.Defense = 0;
        this.Strength = 0;
        this.Level = level;
        this.probabilidad = 20*level;
        primero = true;
    }

    public Curve getStrengthCurve() {
        Random rnd = new Random();
        return new LogaritmCurve((int)(rnd.nextDouble()*100000000+1));
    }

    public Curve getHealthCurve() {
        return new PolinomialCurve();
    }

    public Curve getDefenseCurve() {
        Random rnd = new Random();
        return new SquareRootCurve((int)(rnd.nextDouble()*1000));
    }

    public void action(CharacterClass character) {

        while (true) {
            if (primero) {
                int aux = this.Defense-character.Strength;
                if (aux >=0) {
                    this.Health -= 5;
                    System.out.println("I hurt him 5 of his life");
                } else {
                    this.Health += aux;
                    System.out.println("I hurt him "+Math.abs(aux)+" of his life");
                } if (this.Health <= 0) {
                    break;
                }
                int aux2 = character.Defense-this.Strength;
                if (aux2 >= 0) {
                    character.Health -= 5;
                    System.out.println("WTF? He hurt me 5 points of my life");
                } else{
                    character.Health += aux2;
                    System.out.println("WTF? He hurt me "+Math.abs(aux2)+" points of my life");
                } if(character.Health <= 0) {
                    break;
                }
            } else {
                int aux = character.Defense-this.Strength;
                if (aux >= 0) {
                    character.Health -= 5;
                    System.out.println("WTF? He hurt me 5 points of my life");
                } else {
                    character.Health += aux;
                    System.out.println("WTF? He hurt me "+Math.abs(aux)+" points of my life");
                } if (character.Health <= 0){
                    break;
                }
                int aux2 = this.Defense-character.Strength;
                if (aux2 >= 0) {
                    this.Health -= 5;
                    System.out.println("I hurt him 5 of his life");
                } else {
                    this.Health +=aux2;
                    System.out.println("I hurt him "+Math.abs(aux2)+" of his life");
                }
                if (this.Health <= 0) {
                    break;
                }
            }
        }
        primero = true;
    }

    public int getProbabilidad(){
        return probabilidad;
    }
}
