package com.company;

import java.util.Random;

public class ItemClass implements CurveBasedAttributes, Event {

    String name;
    int Health;
    int Defense;
    int Strength;
    int Level;

    public ItemClass(String name,int Level) {
        this.name = name;
        this.Health = 0;
        this.Defense = 0;
        this.Strength = 0;
        this.Level = Level;
    }

    public Curve getStrengthCurve() {
        Random rnd = new Random();
        return new LinealCurve((int)(rnd.nextDouble()*50),(int)(rnd.nextDouble()*50));
    }

    public Curve getHealthCurve() {
        return new PolinomialCurve();
    }

    public Curve getDefenseCurve() {
        Random rnd = new Random();
        return new ConstantCurve((int)(rnd.nextDouble()*10));
    }

    public void action(CharacterClass character) {
        if (this.Health != 0) {
            character.Health = character.Health + this.Health;
        } else if (this.Defense != 0) {
            character.Defense = character.Defense + this.Defense;
        } else {
            character.Strength = character.Strength + this.Strength;
        }
    }
}
