package com.company;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Random;
import java.util.Scanner;

public class Main {

    public static void main(String[] args) throws IOException {

        String cadena;
        boolean bool = true;
        FileReader f= new FileReader(args[0]);
        BufferedReader b = new BufferedReader(f);
        CharacterClass MainCharacter = new CharacterClass();
        ArrayList<EnemieClass> Enemies = new ArrayList<>();
        ArrayList<ItemClass> Items = new ArrayList<>();
        Proveedor proveedor = new Proveedor();
        Graph Graph = new Graph();
        String[] temp;

        while ((cadena = b.readLine())!=null) {
            if (cadena.contains(":")) {
                if (cadena.contains("Health") && !cadena.contains("HealthPotion")) {
                    temp = cadena.split(":");
                    MainCharacter.Health = Integer.parseInt(temp[1]);
                } else if (cadena.contains("Defense")) {
                    temp = cadena.split(":");
                    MainCharacter.Defense = Integer.parseInt(temp[1]);
                } else if (cadena.contains("Strength")) {
                    temp = cadena.split(":");
                    MainCharacter.Strength = Integer.parseInt(temp[1]);
                }
            } if (cadena.contains(",")) {
                temp = cadena.split(":");
                String[] aux = temp[1].split(",");
                String[] aux2 = temp[2].split(",");
                if (bool) {
                    MainCharacter.position = temp[0];
                    bool = false;
                }
                if (aux2[0].length() == 3) {
                    EnemieClass enemieaux = new EnemieClass(aux2[0], Integer.parseInt(aux2[1]));
                    Graph.addNodes(temp[0], Integer.parseInt(aux[0]), Integer.parseInt(aux[1]), aux2[0], enemieaux, 0);
                    while (true) {
                        SquareRootCurve curvauxiliar = (SquareRootCurve) enemieaux.getDefenseCurve();
                        int[] factor = new int[1];
                        factor[0] = curvauxiliar.fact;
                        if (!proveedor.checkCurve(factor, 4)) {
                            enemieaux.Defense = curvauxiliar.getCurve(enemieaux.Level);
                            proveedor.addCurve(factor, 4);
                            break;
                        }
                    }
                    while (true) {
                        LogaritmCurve curvauxiliar = (LogaritmCurve) enemieaux.getStrengthCurve();
                        int[] factor = new int[1];
                        factor[0] = curvauxiliar.fact;
                        if (!proveedor.checkCurve(factor, 3)) {
                            enemieaux.Strength = curvauxiliar.getCurve(enemieaux.Level);
                            proveedor.addCurve(factor, 3);
                            break;
                        }
                    }
                    while (true) {
                        PolinomialCurve curvauxiliar = (PolinomialCurve) enemieaux.getHealthCurve();
                        int largo = curvauxiliar.Polinom.size();
                        int[] factor = new int[largo];
                        for (int i = 0; i < largo; i++) {
                            factor[i] = curvauxiliar.Polinom.get(i);
                        }
                        if (!proveedor.checkCurve(factor, 2)) {
                            enemieaux.Health = curvauxiliar.getCurve(enemieaux.Level);
                            proveedor.addCurve(factor, 2);
                            break;
                        }
                    }
                    Enemies.add(enemieaux);
                } else {
                    ItemClass Itemaux = new ItemClass(aux2[0], Integer.parseInt(aux2[1]));
                    Graph.addNodes(temp[0], Integer.parseInt(aux[0]), Integer.parseInt(aux[1]), aux2[0], Itemaux, 1);
                    Items.add(Itemaux);
                }
            } else if (cadena.contains("->")) {
                temp = cadena.split("->");
                for (int i=0; i<Graph.nodes.size(); i++) {
                    if ((Graph.nodes.get(i).nameNode).equals(temp[0])) {
                        NodeClass aux = Graph.nodes.get(i);
                        for (int k=0; k<Graph.nodes.size(); k++) {
                            if ((Graph.nodes.get(k).nameNode).equals(temp[1])) {
                                Graph.addLinks(aux, temp[1],Graph.nodes.get(k).Cordx, Graph.nodes.get(k).CordY);
                            }
                        }
                    }
                    else if ((Graph.nodes.get(i).nameNode).equals(temp[1])) {
                        NodeClass aux = Graph.nodes.get(i);
                        for (int k=0; k<Graph.nodes.size(); k++) {
                            if ((Graph.nodes.get(k).nameNode).equals(temp[0])) {
                                Graph.addLinks(aux, temp[0], Graph.nodes.get(k).Cordx, Graph.nodes.get(k).CordY);
                            }
                        }

                    }
                }
            } else if (cadena.contains("/")) {
                temp = cadena.split("/");
                int size = Items.size();
                for (int i = 0; i<size; i++) {
                    if (temp[0].equals(Items.get(i).name)) {
                        if(temp[1].equals("Health")) {
                            while (true) {
                                PolinomialCurve curvilla = (PolinomialCurve)Items.get(i).getHealthCurve();
                                int largo = curvilla.Polinom.size();
                                int[] factor = new int[largo];
                                for (int j =0;j<largo; j++) {
                                    factor[j] = curvilla.Polinom.get(j);
                                }
                                if (!proveedor.checkCurve(factor,2)) {
                                    Items.get(i).Health = curvilla.getCurve(Items.get(i).Level);
                                    proveedor.addCurve(factor, 2);
                                    break;
                                }
                            }
                        } else if (temp[1].equals("Defense")) {
                            while (true) {
                                int[] factor = new int[1];
                                ConstantCurve curvilla = (ConstantCurve)Items.get(i).getDefenseCurve();
                                factor[0] = curvilla.Constant;
                                if (!proveedor.checkCurve(factor,0)) {
                                    Items.get(i).Defense = curvilla.getCurve(Items.get(i).Level);
                                    proveedor.addCurve(factor, 0);
                                    break;
                                }
                            }
                        } else {
                            while (true) {
                                int[] factor = new int[2];
                                LinealCurve curvilla = (LinealCurve)Items.get(i).getStrengthCurve();
                                factor[0] = curvilla.Intercept;
                                factor[1] = curvilla.Pending;
                                if (!proveedor.checkCurve(factor,1)) {
                                    Items.get(i).Strength = curvilla.getCurve(Items.get(i).Level);
                                    proveedor.addCurve(factor, 1);
                                    break;
                                }
                            }
                        }
                    }
                }
            }
        }
        b.close();

        System.out.println("Finally I 'm here in the USM . I don't know why I started in the building " + MainCharacter.position + " but who cares. Let's go!");

        while (true) {
            Scanner op = new Scanner(System.in);
            String comando = op.next();
            if (comando.equals("walk")) {
                int size = Graph.nodes.size();
                for (int i=0; i<size; i++) {
                    if (Graph.nodes.get(i).typeofevent == 0 && Graph.nodes.get(i).nameNode.equals(MainCharacter.position) && Graph.nodes.get(i).factor == 0) {
                        Random rnd = new Random();
                        int size2 = Enemies.size();
                        for(int j=0;j<size2 ; j++) {
                            if (Enemies.get(i).name.equals(Graph.nodes.get(i).nameEvent)) {
                                if ((rnd.nextDouble()*100) < Enemies.get(i).probabilidad) {
                                    Enemies.get(i).primero = false;
                                    Enemies.get(i).action(MainCharacter);
                                    Graph.nodes.get(i).factor = 1;
                                    break;
                                }
                            }
                        }
                        break;
                    }
                }
                if (MainCharacter.Health <= 0) {
                    break;
                }
                int number = op.nextInt();
                for (int i=0; i<size; i++) {
                    if(Graph.nodes.get(i).nameNode.equals(MainCharacter.position)) {
                        MainCharacter.walk(Graph.nodes.get(i), number);
                        break;
                    }
                }
            } else if (comando.equals("investigate")) {
                int size = Graph.nodes.size();
                for (int i = 0; i < size; i++) {
                    if (Graph.nodes.get(i).nameNode.equals(MainCharacter.position)) {
                        MainCharacter.investigate(Graph.nodes.get(i), MainCharacter);
                        break;
                    }
                }
                if (MainCharacter.Health <= 0) {
                    break;
                }
            } else if (comando.equals("inventory")) {
                MainCharacter.inventory();
            } else if (comando.equals("use")) {
                int id = op.nextInt();
                int size = Items.size();
                for (int i = 0;i<size; i++) {
                    if (Items.get(i).name.equals(MainCharacter.inventory[id])) {
                        MainCharacter.use(id,Items.get(i));
                        break;
                    }
                }
            } else {
                int number = op.nextInt();
                MainCharacter.drop(number);
            }
        }
        System.out.println("YOU DIED");
    }
}
