package com.company;

import java.util.ArrayList;

public class Proveedor {

    ArrayList<Integer> Constants;
    ArrayList<String> Lineal;
    ArrayList<String> Polinomial;
    ArrayList<Integer> Logaritm;
    ArrayList<Integer> SquareRoot;

    public Proveedor() {
        Constants = new ArrayList<>();
        Lineal = new ArrayList<>();
        Polinomial = new ArrayList<>();
        Logaritm = new ArrayList<>();
        SquareRoot = new ArrayList<>();
    }

    boolean checkCurve(int[] coefficients , int type) {
        if (type == 0){
            int size = Constants.size();
            for (int i=0; i<size; i++) {
                if (Constants.get(i) == coefficients[0]) {
                    return true;
                }
            }
            return false;
        } else if (type == 1) {
            int size = Lineal.size();
            for (int i=0; i<size ; i++) {
                String[] temp = Lineal.get(i).split(",");
                if (Integer.parseInt(temp[0]) == coefficients[0] && Integer.parseInt(temp[1]) == coefficients[1]) {
                    return true;
                }
            }
            return false;
        } else if (type == 2) {
            int size = Polinomial.size();
            int count;
            for (int i=0; i<size; i++) {
                String[] temp = Polinomial.get(i).split(",");
                if (temp.length == coefficients.length) {
                    for (int j=0; j<temp.length; j++) {
                        count = 0;
                        for (int k=0; k<coefficients.length; k++) {
                            if (Integer.parseInt(temp[j]) == coefficients[k]) {
                                count++;
                            }
                        }
                        if (count == coefficients.length) {
                            return true;
                        }
                    }
                }
            }
            return false;
        } else if (type == 3) {
            int size = Logaritm.size();
            for (int i=0; i<size; i++){
                if (Logaritm.get(i) == coefficients[0]) {
                    return true;
                }
            }
            return false;
        } else {
            int size = SquareRoot.size();
            for (int i=0;i<size; i++) {
                if (SquareRoot.get(i) == coefficients[0]) {
                    return true;
                }
            }
            return false;
        }
    }

    void addCurve(int[] coefficients, int type) {

        if (type == 0) {
            Constants.add(coefficients[0]);
        } else if (type == 1) {
            String LinealNumber = coefficients[0]+","+coefficients[1];
            Lineal.add(LinealNumber);
        } else if (type == 2) {
            String name = Integer.toString(coefficients[0]);
            for (int i=0; i < coefficients.length; i++) {
                name = name + ',' + coefficients[i];
            }
        } else if (type == 3) {
            Logaritm.add(coefficients[0]);
        } else {
            SquareRoot.add(coefficients[0]);
        }
    }
}
